<?php
class Bitfoundry_Etnpay_Helper_Data extends Mage_Payment_Helper_Data {

    public function isMobile() {
        require_once("Mobile_Detect.php");

        $mobileDetect = new Mobile_Detect;

        if ($mobileDetect->isMobile()) {
            return 1;
        }

        return 0;
    }

    public function createSecuritySignature($payloadArr, $apiSecret)
    {
        $hash = hash_hmac('sha256', json_encode($payloadArr), $apiSecret);

        return $hash;
    }

    public function getIp()
    {
        //Just get the headers if we can or else use the SERVER global
        if ( function_exists( 'apache_request_headers' ) ) {
            $headers = apache_request_headers();
        } else {
            $headers = $_SERVER;
        }
        //Get the forwarded IP if it exists
        if ( array_key_exists( 'X-Forwarded-For', $headers ) && filter_var( $headers['X-Forwarded-For'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV4 ) ) {
            $the_ip = $headers['X-Forwarded-For'];
        } elseif ( array_key_exists( 'HTTP_X_FORWARDED_FOR', $headers ) && filter_var( $headers['HTTP_X_FORWARDED_FOR'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV4 )
        ) {
            $the_ip = $headers['HTTP_X_FORWARDED_FOR'];
        } else {
            $the_ip = filter_var( $_SERVER['REMOTE_ADDR'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV4 );
        }

        return $the_ip;
    }

    // get the value of ETN required for payment
    public function getETNAmount($currencyCode, $amount) {
        // Get the JSON conversion data.
        if (!$json = file_get_contents('https://supply.electroneum.com/app-value-v2.json')) {
            die("Could not load currency exchange JSON");
        }

        // Check the JSON is valid.
        $arr = json_decode($json, true);
        if (json_last_error() !== JSON_ERROR_NONE) {
            die("Could not load valid currency exchange JSON");
        }

        // Get the conversion rate.
        if (!$rate = $arr['price_' . strtolower($currencyCode)]) {
            die("Currency exchange rate not found");
        }

        // Check the rate is valid or more than zero.
        if (floatval($rate) <= 0) {
            die("Currency conversion rate not valid");
        }

        // Calculate the amount of ETN.
        $etn = number_format(floatval($amount) / $rate, 2, '.', '');

        return $etn;
    }
}
